Index: WebCore/GNUmakefile.am
===================================================================
--- WebCore/GNUmakefile.am	(revision 35758)
+++ WebCore/GNUmakefile.am	(working copy)
@@ -2225,7 +2852,35 @@
 	DerivedSources/JSTimeRanges.cpp \
 	DerivedSources/JSTimeRanges.h \
 	DerivedSources/JSVoidCallback.cpp \
-	DerivedSources/JSVoidCallback.h
+	DerivedSources/JSVoidCallback.h \
+	DerivedSources/GdomHTMLAudioElement.cpp \
+	DerivedSources/GdomHTMLAudioElement.h \
+	DerivedSources/GdomHTMLMediaElement.cpp \
+	DerivedSources/GdomHTMLMediaElement.h \
+	DerivedSources/GdomHTMLSourceElement.cpp \
+	DerivedSources/GdomHTMLSourceElement.h \
+	DerivedSources/GdomHTMLVideoElement.cpp \
+	DerivedSources/GdomHTMLVideoElement.h \
+	DerivedSources/GdomMediaError.cpp \
+	DerivedSources/GdomMediaError.h \
+	DerivedSources/GdomTimeRanges.cpp \
+	DerivedSources/GdomTimeRanges.h \
+	DerivedSources/GdomVoidCallback.cpp \
+	DerivedSources/GdomVoidCallback.h \
+	DerivedSources/PrivateGdomHTMLAudioElement.cpp \
+	DerivedSources/PrivateGdomHTMLAudioElement.h \
+	DerivedSources/PrivateGdomHTMLMediaElement.cpp \
+	DerivedSources/PrivateGdomHTMLMediaElement.h \
+	DerivedSources/PrivateGdomHTMLSourceElement.cpp \
+	DerivedSources/PrivateGdomHTMLSourceElement.h \
+	DerivedSources/PrivateGdomHTMLVideoElement.cpp \
+	DerivedSources/PrivateGdomHTMLVideoElement.h \
+	DerivedSources/PrivateGdomMediaError.cpp \
+	DerivedSources/PrivateGdomMediaError.h \
+	DerivedSources/PrivateGdomTimeRanges.cpp \
+	DerivedSources/PrivateGdomTimeRanges.h \
+	DerivedSources/PrivateGdomVoidCallback.cpp \
+	DerivedSources/PrivateGdomVoidCallback.h
 
 IDL_BINDINGS += \
 	WebCore/html/HTMLAudioElement.idl \
@@ -2269,6 +2924,7 @@
 # ----
 if ENABLE_XPATH
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_XPATH=1
+FEATURE_DEFINES_GDOM += ENABLE_XPATH=1
 
 webcore_cppflags += -DENABLE_XPATH=1
 
@@ -2284,7 +2940,27 @@
 	DerivedSources/JSXPathResult.cpp \
 	DerivedSources/JSXPathResult.h \
 	DerivedSources/XPathGrammar.cpp \
-	DerivedSources/XPathGrammar.h
+	DerivedSources/XPathGrammar.h \
+	DerivedSources/GdomXPathEvaluator.cpp \
+	DerivedSources/GdomXPathEvaluator.h \
+	DerivedSources/GdomXPathException.cpp \
+	DerivedSources/GdomXPathException.h \
+	DerivedSources/GdomXPathExpression.cpp \
+	DerivedSources/GdomXPathExpression.h \
+	DerivedSources/GdomXPathNSResolver.cpp \
+	DerivedSources/GdomXPathNSResolver.h \
+	DerivedSources/GdomXPathResult.cpp \
+	DerivedSources/GdomXPathResult.h \
+	DerivedSources/PrivateGdomXPathEvaluator.cpp \
+	DerivedSources/PrivateGdomXPathEvaluator.h \
+	DerivedSources/PrivateGdomXPathException.cpp \
+	DerivedSources/PrivateGdomXPathException.h \
+	DerivedSources/PrivateGdomXPathExpression.cpp \
+	DerivedSources/PrivateGdomXPathExpression.h \
+	DerivedSources/PrivateGdomXPathNSResolver.cpp \
+	DerivedSources/PrivateGdomXPathNSResolver.h \
+	DerivedSources/PrivateGdomXPathResult.cpp \
+	DerivedSources/PrivateGdomXPathResult.h
 
 IDL_BINDINGS += \
 	WebCore/xml/XPathEvaluator.idl \
@@ -2349,6 +3025,7 @@
 # ----
 if ENABLE_XSLT
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_XSLT=1
+FEATURE_DEFINES_GDOM += ENABLE_XSLT=1
 
 webcore_cppflags += -DENABLE_XSLT=1
 
@@ -2372,6 +3049,7 @@
 # ----
 if ENABLE_SVG
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG=1 - big TODO! :)
 
 WEBCORE_CSS_PROPERTY_NAMES += $(WebCore)/css/SVGCSSPropertyNames.in 
 WEBCORE_CSS_VALUE_KEYWORDS += $(WebCore)/css/SVGCSSValueKeywords.in
@@ -2649,6 +3327,273 @@
 	DerivedSources/SVGNames.cpp \
 	DerivedSources/XLinkNames.cpp
 
+not-yet:
+	DerivedSources/GdomSVGAElement.cpp \
+	DerivedSources/GdomSVGAElement.h \
+	DerivedSources/GdomSVGAltGlyphElement.cpp \
+	DerivedSources/GdomSVGAltGlyphElement.h \
+	DerivedSources/GdomSVGAngle.cpp \
+	DerivedSources/GdomSVGAngle.h \
+	DerivedSources/GdomSVGAnimateColorElement.cpp \
+	DerivedSources/GdomSVGAnimateColorElement.h \
+	DerivedSources/GdomSVGAnimateElement.cpp \
+	DerivedSources/GdomSVGAnimateElement.h \
+	DerivedSources/GdomSVGAnimateTransformElement.cpp \
+	DerivedSources/GdomSVGAnimateTransformElement.h \
+	DerivedSources/GdomSVGAnimatedAngle.cpp \
+	DerivedSources/GdomSVGAnimatedAngle.h \
+	DerivedSources/GdomSVGAnimatedBoolean.cpp \
+	DerivedSources/GdomSVGAnimatedBoolean.h \
+	DerivedSources/GdomSVGAnimatedEnumeration.cpp \
+	DerivedSources/GdomSVGAnimatedEnumeration.h \
+	DerivedSources/GdomSVGAnimatedInteger.cpp \
+	DerivedSources/GdomSVGAnimatedInteger.h \
+	DerivedSources/GdomSVGAnimatedLength.cpp \
+	DerivedSources/GdomSVGAnimatedLength.h \
+	DerivedSources/GdomSVGAnimatedLengthList.cpp \
+	DerivedSources/GdomSVGAnimatedLengthList.h \
+	DerivedSources/GdomSVGAnimatedNumber.cpp \
+	DerivedSources/GdomSVGAnimatedNumber.h \
+	DerivedSources/GdomSVGAnimatedNumberList.cpp \
+	DerivedSources/GdomSVGAnimatedNumberList.h \
+	DerivedSources/GdomSVGAnimatedPreserveAspectRatio.cpp \
+	DerivedSources/GdomSVGAnimatedPreserveAspectRatio.h \
+	DerivedSources/GdomSVGAnimatedRect.cpp \
+	DerivedSources/GdomSVGAnimatedRect.h \
+	DerivedSources/GdomSVGAnimatedString.cpp \
+	DerivedSources/GdomSVGAnimatedString.h \
+	DerivedSources/GdomSVGAnimatedTransformList.cpp \
+	DerivedSources/GdomSVGAnimatedTransformList.h \
+	DerivedSources/GdomSVGAnimationElement.cpp \
+	DerivedSources/GdomSVGAnimationElement.h \
+	DerivedSources/GdomSVGCircleElement.cpp \
+	DerivedSources/GdomSVGCircleElement.h \
+	DerivedSources/GdomSVGClipPathElement.cpp \
+	DerivedSources/GdomSVGClipPathElement.h \
+	DerivedSources/GdomSVGColor.cpp \
+	DerivedSources/GdomSVGColor.h \
+	DerivedSources/GdomSVGComponentTransferFunctionElement.cpp \
+	DerivedSources/GdomSVGComponentTransferFunctionElement.h \
+	DerivedSources/GdomSVGCursorElement.cpp \
+	DerivedSources/GdomSVGCursorElement.h \
+	DerivedSources/GdomSVGDefinitionSrcElement.cpp \
+	DerivedSources/GdomSVGDefinitionSrcElement.h \
+	DerivedSources/GdomSVGDefsElement.cpp \
+	DerivedSources/GdomSVGDefsElement.h \
+	DerivedSources/GdomSVGDescElement.cpp \
+	DerivedSources/GdomSVGDescElement.h \
+	DerivedSources/GdomSVGDocument.cpp \
+	DerivedSources/GdomSVGDocument.h \
+	DerivedSources/GdomSVGElement.cpp \
+	DerivedSources/GdomSVGElement.h \
+	DerivedSources/GdomSVGElementInstance.cpp \
+	DerivedSources/GdomSVGElementInstance.h \
+	DerivedSources/GdomSVGElementInstanceList.cpp \
+	DerivedSources/GdomSVGElementInstanceList.h \
+	DerivedSources/GdomSVGElementWrapperFactory.cpp \
+	DerivedSources/GdomSVGEllipseElement.cpp \
+	DerivedSources/GdomSVGEllipseElement.h \
+	DerivedSources/GdomSVGException.cpp \
+	DerivedSources/GdomSVGException.h \
+	DerivedSources/GdomSVGFEBlendElement.cpp \
+	DerivedSources/GdomSVGFEBlendElement.h \
+	DerivedSources/GdomSVGFEColorMatrixElement.cpp \
+	DerivedSources/GdomSVGFEColorMatrixElement.h \
+	DerivedSources/GdomSVGFEComponentTransferElement.cpp \
+	DerivedSources/GdomSVGFEComponentTransferElement.h \
+	DerivedSources/GdomSVGFECompositeElement.cpp \
+	DerivedSources/GdomSVGFECompositeElement.h \
+	DerivedSources/GdomSVGFEDiffuseLightingElement.cpp \
+	DerivedSources/GdomSVGFEDiffuseLightingElement.h \
+	DerivedSources/GdomSVGFEDisplacementMapElement.cpp \
+	DerivedSources/GdomSVGFEDisplacementMapElement.h \
+	DerivedSources/GdomSVGFEDistantLightElement.cpp \
+	DerivedSources/GdomSVGFEDistantLightElement.h \
+	DerivedSources/GdomSVGFEFloodElement.cpp \
+	DerivedSources/GdomSVGFEFloodElement.h \
+	DerivedSources/GdomSVGFEFuncAElement.cpp \
+	DerivedSources/GdomSVGFEFuncAElement.h \
+	DerivedSources/GdomSVGFEFuncBElement.cpp \
+	DerivedSources/GdomSVGFEFuncBElement.h \
+	DerivedSources/GdomSVGFEFuncGElement.cpp \
+	DerivedSources/GdomSVGFEFuncGElement.h \
+	DerivedSources/GdomSVGFEFuncRElement.cpp \
+	DerivedSources/GdomSVGFEFuncRElement.h \
+	DerivedSources/GdomSVGFEGaussianBlurElement.cpp \
+	DerivedSources/GdomSVGFEGaussianBlurElement.h \
+	DerivedSources/GdomSVGFEImageElement.cpp \
+	DerivedSources/GdomSVGFEImageElement.h \
+	DerivedSources/GdomSVGFEMergeElement.cpp \
+	DerivedSources/GdomSVGFEMergeElement.h \
+	DerivedSources/GdomSVGFEMergeNodeElement.cpp \
+	DerivedSources/GdomSVGFEMergeNodeElement.h \
+	DerivedSources/GdomSVGFEOffsetElement.cpp \
+	DerivedSources/GdomSVGFEOffsetElement.h \
+	DerivedSources/GdomSVGFEPointLightElement.cpp \
+	DerivedSources/GdomSVGFEPointLightElement.h \
+	DerivedSources/GdomSVGFESpecularLightingElement.cpp \
+	DerivedSources/GdomSVGFESpecularLightingElement.h \
+	DerivedSources/GdomSVGFESpotLightElement.cpp \
+	DerivedSources/GdomSVGFESpotLightElement.h \
+	DerivedSources/GdomSVGFETileElement.cpp \
+	DerivedSources/GdomSVGFETileElement.h \
+	DerivedSources/GdomSVGFETurbulenceElement.cpp \
+	DerivedSources/GdomSVGFETurbulenceElement.h \
+	DerivedSources/GdomSVGFilterElement.cpp \
+	DerivedSources/GdomSVGFilterElement.h \
+	DerivedSources/GdomSVGFontElement.cpp \
+	DerivedSources/GdomSVGFontElement.h \
+	DerivedSources/GdomSVGFontFaceElement.cpp \
+	DerivedSources/GdomSVGFontFaceElement.h \
+	DerivedSources/GdomSVGFontFaceFormatElement.cpp \
+	DerivedSources/GdomSVGFontFaceFormatElement.h \
+	DerivedSources/GdomSVGFontFaceNameElement.cpp \
+	DerivedSources/GdomSVGFontFaceNameElement.h \
+	DerivedSources/GdomSVGFontFaceSrcElement.cpp \
+	DerivedSources/GdomSVGFontFaceSrcElement.h \
+	DerivedSources/GdomSVGFontFaceUriElement.cpp \
+	DerivedSources/GdomSVGFontFaceUriElement.h \
+	DerivedSources/GdomSVGForeignObjectElement.cpp \
+	DerivedSources/GdomSVGForeignObjectElement.h \
+	DerivedSources/GdomSVGGElement.cpp \
+	DerivedSources/GdomSVGGElement.h \
+	DerivedSources/GdomSVGGlyphElement.cpp \
+	DerivedSources/GdomSVGGlyphElement.h \
+	DerivedSources/GdomSVGGradientElement.cpp \
+	DerivedSources/GdomSVGGradientElement.h \
+	DerivedSources/GdomSVGImageElement.cpp \
+	DerivedSources/GdomSVGImageElement.h \
+	DerivedSources/GdomSVGLength.cpp \
+	DerivedSources/GdomSVGLength.h \
+	DerivedSources/GdomSVGLengthList.cpp \
+	DerivedSources/GdomSVGLengthList.h \
+	DerivedSources/GdomSVGLineElement.cpp \
+	DerivedSources/GdomSVGLineElement.h \
+	DerivedSources/GdomSVGLinearGradientElement.cpp \
+	DerivedSources/GdomSVGLinearGradientElement.h \
+	DerivedSources/GdomSVGMarkerElement.cpp \
+	DerivedSources/GdomSVGMarkerElement.h \
+	DerivedSources/GdomSVGMaskElement.cpp \
+	DerivedSources/GdomSVGMaskElement.h \
+	DerivedSources/GdomSVGMatrix.cpp \
+	DerivedSources/GdomSVGMatrix.h \
+	DerivedSources/GdomSVGMetadataElement.cpp \
+	DerivedSources/GdomSVGMetadataElement.h \
+	DerivedSources/GdomSVGMissingGlyphElement.cpp \
+	DerivedSources/GdomSVGMissingGlyphElement.h \
+	DerivedSources/GdomSVGNumber.cpp \
+	DerivedSources/GdomSVGNumber.h \
+	DerivedSources/GdomSVGNumberList.cpp \
+	DerivedSources/GdomSVGNumberList.h \
+	DerivedSources/GdomSVGPaint.cpp \
+	DerivedSources/GdomSVGPaint.h \
+	DerivedSources/GdomSVGPathElement.cpp \
+	DerivedSources/GdomSVGPathElement.h \
+	DerivedSources/GdomSVGPathSeg.cpp \
+	DerivedSources/GdomSVGPathSeg.h \
+	DerivedSources/GdomSVGPathSegArcAbs.cpp \
+	DerivedSources/GdomSVGPathSegArcAbs.h \
+	DerivedSources/GdomSVGPathSegArcRel.cpp \
+	DerivedSources/GdomSVGPathSegArcRel.h \
+	DerivedSources/GdomSVGPathSegClosePath.cpp \
+	DerivedSources/GdomSVGPathSegClosePath.h \
+	DerivedSources/GdomSVGPathSegCurvetoCubicAbs.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoCubicAbs.h \
+	DerivedSources/GdomSVGPathSegCurvetoCubicRel.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoCubicRel.h \
+	DerivedSources/GdomSVGPathSegCurvetoCubicSmoothAbs.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoCubicSmoothAbs.h \
+	DerivedSources/GdomSVGPathSegCurvetoCubicSmoothRel.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoCubicSmoothRel.h \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticAbs.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticAbs.h \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticRel.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticRel.h \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticSmoothAbs.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticSmoothAbs.h \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticSmoothRel.cpp \
+	DerivedSources/GdomSVGPathSegCurvetoQuadraticSmoothRel.h \
+	DerivedSources/GdomSVGPathSegLinetoAbs.cpp \
+	DerivedSources/GdomSVGPathSegLinetoAbs.h \
+	DerivedSources/GdomSVGPathSegLinetoHorizontalAbs.cpp \
+	DerivedSources/GdomSVGPathSegLinetoHorizontalAbs.h \
+	DerivedSources/GdomSVGPathSegLinetoHorizontalRel.cpp \
+	DerivedSources/GdomSVGPathSegLinetoHorizontalRel.h \
+	DerivedSources/GdomSVGPathSegLinetoRel.cpp \
+	DerivedSources/GdomSVGPathSegLinetoRel.h \
+	DerivedSources/GdomSVGPathSegLinetoVerticalAbs.cpp \
+	DerivedSources/GdomSVGPathSegLinetoVerticalAbs.h \
+	DerivedSources/GdomSVGPathSegLinetoVerticalRel.cpp \
+	DerivedSources/GdomSVGPathSegLinetoVerticalRel.h \
+	DerivedSources/GdomSVGPathSegList.cpp \
+	DerivedSources/GdomSVGPathSegList.h \
+	DerivedSources/GdomSVGPathSegMovetoAbs.cpp \
+	DerivedSources/GdomSVGPathSegMovetoAbs.h \
+	DerivedSources/GdomSVGPathSegMovetoRel.cpp \
+	DerivedSources/GdomSVGPathSegMovetoRel.h \
+	DerivedSources/GdomSVGPatternElement.cpp \
+	DerivedSources/GdomSVGPatternElement.h \
+	DerivedSources/GdomSVGPoint.cpp \
+	DerivedSources/GdomSVGPoint.h \
+	DerivedSources/GdomSVGPointList.cpp \
+	DerivedSources/GdomSVGPointList.h \
+	DerivedSources/GdomSVGPolygonElement.cpp \
+	DerivedSources/GdomSVGPolygonElement.h \
+	DerivedSources/GdomSVGPolylineElement.cpp \
+	DerivedSources/GdomSVGPolylineElement.h \
+	DerivedSources/GdomSVGPreserveAspectRatio.cpp \
+	DerivedSources/GdomSVGPreserveAspectRatio.h \
+	DerivedSources/GdomSVGRadialGradientElement.cpp \
+	DerivedSources/GdomSVGRadialGradientElement.h \
+	DerivedSources/GdomSVGRect.cpp \
+	DerivedSources/GdomSVGRect.h \
+	DerivedSources/GdomSVGRectElement.cpp \
+	DerivedSources/GdomSVGRectElement.h \
+	DerivedSources/GdomSVGRenderingIntent.cpp \
+	DerivedSources/GdomSVGRenderingIntent.h \
+	DerivedSources/GdomSVGSVGElement.cpp \
+	DerivedSources/GdomSVGSVGElement.h \
+	DerivedSources/GdomSVGScriptElement.cpp \
+	DerivedSources/GdomSVGScriptElement.h \
+	DerivedSources/GdomSVGSetElement.cpp \
+	DerivedSources/GdomSVGSetElement.h \
+	DerivedSources/GdomSVGStopElement.cpp \
+	DerivedSources/GdomSVGStopElement.h \
+	DerivedSources/GdomSVGStringList.cpp \
+	DerivedSources/GdomSVGStringList.h \
+	DerivedSources/GdomSVGStyleElement.cpp \
+	DerivedSources/GdomSVGStyleElement.h \
+	DerivedSources/GdomSVGSwitchElement.cpp \
+	DerivedSources/GdomSVGSwitchElement.h \
+	DerivedSources/GdomSVGSymbolElement.cpp \
+	DerivedSources/GdomSVGSymbolElement.h \
+	DerivedSources/GdomSVGTRefElement.cpp \
+	DerivedSources/GdomSVGTRefElement.h \
+	DerivedSources/GdomSVGTSpanElement.cpp \
+	DerivedSources/GdomSVGTSpanElement.h \
+	DerivedSources/GdomSVGTextContentElement.cpp \
+	DerivedSources/GdomSVGTextContentElement.h \
+	DerivedSources/GdomSVGTextElement.cpp \
+	DerivedSources/GdomSVGTextElement.h \
+	DerivedSources/GdomSVGTextPathElement.cpp \
+	DerivedSources/GdomSVGTextPathElement.h \
+	DerivedSources/GdomSVGTextPositioningElement.cpp \
+	DerivedSources/GdomSVGTextPositioningElement.h \
+	DerivedSources/GdomSVGTitleElement.cpp \
+	DerivedSources/GdomSVGTitleElement.h \
+	DerivedSources/GdomSVGTransform.cpp \
+	DerivedSources/GdomSVGTransform.h \
+	DerivedSources/GdomSVGTransformList.cpp \
+	DerivedSources/GdomSVGTransformList.h \
+	DerivedSources/GdomSVGUnitTypes.cpp \
+	DerivedSources/GdomSVGUnitTypes.h \
+	DerivedSources/GdomSVGUseElement.cpp \
+	DerivedSources/GdomSVGUseElement.h \
+	DerivedSources/GdomSVGViewElement.cpp \
+	DerivedSources/GdomSVGViewElement.h \
+	DerivedSources/GdomSVGZoomEvent.cpp \
+	DerivedSources/GdomSVGZoomEvent.h 
+
 IDL_BINDINGS += \
 	WebCore/svg/ElementTimeControl.idl \
 	WebCore/svg/SVGAElement.idl \
@@ -3228,36 +4173,42 @@
 # SVG Features
 if ENABLE_SVG_USE
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG_USE=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG_USE=1 # big TODO!
 SVG_FEATURES += ENABLE_SVG_USE=1
 webcore_cppflags += -DENABLE_SVG_USE=1
 endif
 
 if ENABLE_SVG_FOREIGN_OBJECT
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG_FOREIGN_OBJECT=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG_FOREIGN_OBJECT=1 
 SVG_FEATURES += ENABLE_SVG_FOREIGN_OBJECT=1
 webcore_cppflags += -DENABLE_SVG_FOREIGN_OBJECT=1
 endif
 
 if ENABLE_SVG_FONTS
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG_FONTS=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG_FONTS=1
 SVG_FEATURES += ENABLE_SVG_FONTS=1
 webcore_cppflags += -DENABLE_SVG_FONTS=1
 endif
 
 if ENABLE_SVG_FILTERS
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG_FILTERS=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG_FILTERS=1
 SVG_FEATURES += ENABLE_SVG_FILTERS=1
 webcore_cppflags += -DENABLE_SVG_FILTERS=1
 endif
 
 if ENABLE_SVG_AS_IMAGE
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG_AS_IMAGE=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG_AS_IMAGE=1
 SVG_FEATURES += ENABLE_SVG_AS_IMAGE=1
 webcore_cppflags += -DENABLE_SVG_AS_IMAGE=1
 endif
 
 if ENABLE_SVG_ANIMATION
 FEATURE_DEFINES_JAVASCRIPT += ENABLE_SVG_ANIMATION=1
+#FEATURE_DEFINES_GDOM += ENABLE_SVG_ANIMATION=1
 SVG_FEATURES += ENABLE_SVG_ANIMATION=1
 webcore_cppflags += -DENABLE_SVG_ANIMATION=1
 endif
@@ -3265,13 +4216,14 @@
 # SVG tag and attribute names (need to pass an extra flag if svg experimental features are enabled)
 DerivedSources/SVGNames.cpp: DerivedSources/SVGElementFactory.cpp;
 DerivedSources/JSSVGElementWrapperFactory.cpp: DerivedSources/SVGElementFactory.cpp
+DerivedSources/GdomSVGElementWrapperFactory.cpp: DerivedSources/SVGElementFactory.cpp
 
 if SVG_FLAGS
 DerivedSources/SVGElementFactory.cpp: $(WebCore)/dom/make_names.pl $(WebCore)/svg/svgtags.in $(WebCore)/svg/svgattrs.in
-	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/svg/svgtags.in --attrs $(WebCore)/svg/svgattrs.in --extraDefines "$(SVG_FEATURES)" --outputDir "$(GENSOURCES)"
+	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/svg/svgtags.in --attrs $(WebCore)/svg/svgattrs.in --extraDefines "$(SVG_FEATURES)" --outputDir "$(GENSOURCES)" 
 else
 DerivedSources/SVGElementFactory.cpp: $(WebCore)/dom/make_names.pl $(WebCore)/svg/svgtags.in $(WebCore)/svg/svgattrs.in
-	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/svg/svgtags.in --attrs $(WebCore)/svg/svgattrs.in --outputDir "$(GENSOURCES)"
+	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/svg/svgtags.in --attrs $(WebCore)/svg/svgattrs.in --outputDir "$(GENSOURCES)" 
 
 endif # SVG_FLAGS
 
@@ -3280,7 +4232,7 @@
 DerivedSources/XLinkNames.h: DerivedSources/XLinkNames.cpp;
 
 DerivedSources/XLinkNames.cpp : $(WebCore)/dom/make_names.pl $(WebCore)/svg/xlinkattrs.in
-	$(PERL) -I$(WebCore)/bindings/scripts $< --attrs $(WebCore)/svg/xlinkattrs.in --outputDir "$(GENSOURCES)"
+	$(PERL) -I$(WebCore)/bindings/scripts $< --attrs $(WebCore)/svg/xlinkattrs.in --outputDir "$(GENSOURCES)" 
 
 endif # END ENABLE_SVG
 
@@ -3361,16 +4313,16 @@
 
 if HTML_FLAGS
 DerivedSources/HTMLNames.cpp: $(WebCore)/dom/make_names.pl $(WebCore)/html/HTMLTagNames.in $(WebCore)/html/HTMLAttributeNames.in
-	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/html/HTMLTagNames.in --attrs $(WebCore)/html/HTMLAttributeNames.in --extraDefines "$(HTML_FEATURES)" --outputDir "$(GENSOURCES)"
+	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/html/HTMLTagNames.in --attrs $(WebCore)/html/HTMLAttributeNames.in --extraDefines "$(HTML_FEATURES)" --outputDir "$(GENSOURCES)" 
 else
 DerivedSources/HTMLNames.cpp: $(WebCore)/dom/make_names.pl $(WebCore)/html/HTMLTagNames.in $(WebCore)/html/HTMLAttributeNames.in
-	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/html/HTMLTagNames.in --attrs $(WebCore)/html/HTMLAttributeNames.in --outputDir "$(GENSOURCES)"
+	$(PERL) -I$(WebCore)/bindings/scripts $< --tags $(WebCore)/html/HTMLTagNames.in --attrs $(WebCore)/html/HTMLAttributeNames.in --outputDir "$(GENSOURCES)" 
 endif # HTML_FLAGS
 
 DerivedSources/XMLNames.h: DerivedSources/XMLNames.cpp;
 
 DerivedSources/XMLNames.cpp: $(WebCore)/dom/make_names.pl $(WebCore)/xml/xmlattrs.in
-	$(PERL) -I$(WebCore)/bindings/scripts $< --attrs $(WebCore)/xml/xmlattrs.in --outputDir "$(GENSOURCES)"
+	$(PERL) -I$(WebCore)/bindings/scripts $< --attrs $(WebCore)/xml/xmlattrs.in --outputDir "$(GENSOURCES)" 
 
 vpath %.idl = \
     $(WebCore) \
@@ -3386,6 +4338,15 @@
     $(WebCore)/xml \
     $(WebCore)/plugins
 
+DerivedSources/PrivateGdom%.h: DerivedSources/Gdom%.h;
+
+DerivedSources/PrivateGdom%.cpp: DerivedSources/Gdom%.cpp;
+
+DerivedSources/Gdom%.h: DerivedSources/Gdom%.cpp;
+
+DerivedSources/Gdom%.cpp: %.idl $(SCRIPTS_BINDINGS) $(WebCore)/bindings/scripts/CodeGeneratorGObject.pm
+	$(PERL) -I$(WebCore)/bindings/scripts $(WebCore)/bindings/scripts/generate-bindings.pl --include $(WebCore)/dom --include $(WebCore)/html --include $(WebCore)/css --include $(WebCore)/page --include $(WebCore)/xml --include $(WebCore)/svg --outputDir "$(GENSOURCES)" --defines "$(FEATURE_DEFINES_GDOM)" --generator GObject $<
+
 DerivedSources/JS%.h: DerivedSources/JS%.cpp;
 
 DerivedSources/JS%.cpp: %.idl $(SCRIPTS_BINDINGS) $(WebCore)/bindings/scripts/CodeGeneratorJS.pm
@@ -3401,6 +4362,7 @@
 	WebCore/bindings/scripts/InFilesParser.pm \
 	WebCore/bindings/scripts/generate-bindings.pl \
 	WebCore/bindings/scripts/CodeGeneratorJS.pm \
+	WebCore/bindings/scripts/CodeGeneratorGObject.pm \
 	WebCore/css/html4.css \
 	WebCore/css/quirks.css \
 	WebCore/css/view-source.css \
Index: WebCore/bindings/gdom/PrivateGdomEventTargetNode.cpp
===================================================================
--- WebCore/bindings/gdom/PrivateGdomEventTargetNode.cpp	(revision 0)
+++ WebCore/bindings/gdom/PrivateGdomEventTargetNode.cpp	(revision 0)
@@ -0,0 +1,87 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+
+#include "config.h"
+#include "glib-object.h"
+#include "Node.h"
+#include "GdomEventTargetNode.h"
+#include "PrivateGdomEventTargetNode.h"
+#include "PrivateIntGdomEventTargetNode.h"
+#include "PrivateGdomDOMObject.h" /* yukk: TODO - make this optional */
+#include "webkitmarshal.h"
+#include "GdomEvent.h"
+enum {
+    BROWSER_EVENT,
+    LAST_SIGNAL
+};
+
+static guint event_signals[LAST_SIGNAL] = { 0, };
+
+
+WebCore::Node *
+gdom_event_target_node_get_private(GdomEventTargetNode *request)
+{
+    GDOMEventTargetNode *res;
+    res = static_cast<GDOMEventTargetNode*>(gdom_dom_object_get_private(GDOM_DOM_OBJECT(request)));
+    return reinterpret_cast<WebCore::Node*>(res->impl());
+}
+
+
+extern "C" {
+
+G_DEFINE_TYPE(GdomEventTargetNode, gdom_event_target_node, GDOM_TYPE_NODE);
+
+/*
+struct _GdomEventTargetNodePrivate {
+    class WebCore::EventTargetNode *item;
+};  
+*/
+
+#define GDOM_EVENT_TARGET_NODE_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), GDOM_TYPE_EVENT_TARGET_NODE, GdomEventTargetNodePrivate))
+
+/*
+void
+gdom_event_target_node_set_private(GdomEventTargetNode *request, WebCore::EventTargetNode * item)
+{
+    GdomEventTargetNodePrivate* priv = GDOM_EVENT_TARGET_NODE_GET_PRIVATE(request);
+    priv->item = item;
+}
+*/
+
+static void gdom_event_target_node_finalize(GObject* object)
+{
+    /*GdomEventTargetNode* request = GDOM_EVENT_TARGET_NODE(object);
+    GdomEventTargetNodePrivate* priv = request->priv;*/
+    
+    G_OBJECT_CLASS(gdom_event_target_node_parent_class)->finalize(object);
+}
+
+static void gdom_event_target_node_class_init(GdomEventTargetNodeClass* requestClass)
+{
+    event_signals[BROWSER_EVENT] = g_signal_new("browser-event",
+        G_TYPE_FROM_CLASS(requestClass),
+        (GSignalFlags)(G_SIGNAL_RUN_LAST | G_SIGNAL_ACTION),
+        0,
+        NULL,
+        NULL,
+        webkit_marshal_VOID__OBJECT_BOOLEAN,
+        G_TYPE_NONE, 2,
+        GDOM_TYPE_EVENT, G_TYPE_BOOLEAN);
+
+    G_OBJECT_CLASS(requestClass)->finalize = gdom_event_target_node_finalize;
+
+    /*g_type_class_add_private(requestClass, sizeof(GdomEventTargetNodePrivate));*/
+}
+
+static void gdom_event_target_node_init(GdomEventTargetNode* request)
+{
+    /*GdomEventTargetNodePrivate* priv = GDOM_EVENT_TARGET_NODE_GET_PRIVATE(request);
+    request->priv = priv;*/
+}   
+
+} /* extern "C" */
+
Index: WebCore/bindings/gdom/PrivateGdomEventTargetNode.h
===================================================================
--- WebCore/bindings/gdom/PrivateGdomEventTargetNode.h	(revision 0)
+++ WebCore/bindings/gdom/PrivateGdomEventTargetNode.h	(revision 0)
@@ -0,0 +1,20 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+
+#ifndef __GDOMEventTargetNode_H___PRIV_
+#define __GDOMEventTargetNode_H___PRIV_
+#include "glib-object.h"
+#include "PrivateGdomNode.h"
+class WebCore::Node;
+
+typedef struct _GdomEventTargetNode GdomEventTargetNode;
+
+WEBKIT_API WebCore::Node *
+gdom_event_target_node_get_private(GdomEventTargetNode *request);
+
+#endif
+
Index: WebCore/bindings/gdom/GdomEventTargetNode.cpp
===================================================================
--- WebCore/bindings/gdom/GdomEventTargetNode.cpp	(revision 0)
+++ WebCore/bindings/gdom/GdomEventTargetNode.cpp	(revision 0)
@@ -0,0 +1,41 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+#include "config.h"
+
+#include <wtf/GetPtr.h>
+#include "CString.h"
+#include "PlatformString.h"
+#include "AtomicString.h"
+#include "EventTargetNode.h"
+#include "GdomEventTargetNode.h"
+#include "PrivateGdomEventTargetNode.h"
+#include "glib-object.h"
+
+class GStringConvert {
+    public:
+    const gchar *m_str;
+    GStringConvert(WebCore::String const& s) { m_str = g_strdup(s.utf8().data()); }
+    GStringConvert(WebCore::AtomicString const&s) { m_str = g_strdup(s.string().utf8().data()); }
+};
+
+extern "C" {
+
+#define _G_GET_UTF8(str) (GStringConvert(str).m_str)
+
+void
+gdom_event_target_node_init_event_target_node (GdomEventTargetNode *thiz)
+{
+    g_return_if_fail (thiz);
+    /*
+    WebCore::EventTargetNode * item = gdom_event_target_node_get_private(thiz);
+    WebCore::String _g_event_target_node_type_arg = WebCore::String(event_target_node_type_arg);
+    item->initEventTargetNode(_g_event_target_node_type_arg);
+    */
+}
+
+} /* extern "C" */
+
Index: WebCore/bindings/gdom/PrivateGdomDOMObject.cpp
===================================================================
--- WebCore/bindings/gdom/PrivateGdomDOMObject.cpp	(revision 0)
+++ WebCore/bindings/gdom/PrivateGdomDOMObject.cpp	(revision 0)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+
+#include "config.h"
+#include "glib-object.h"
+#include "Node.h"
+#include "GdomDOMObject.h"
+#include "GDOMObject.h"
+#include "PrivateGdomDOMObject.h"
+
+extern "C" {
+
+G_DEFINE_TYPE(GdomDOMObject, gdom_dom_object, G_TYPE_OBJECT);
+
+struct _GdomDOMObjectPrivate {
+     GDOMObject *m_node;
+};  
+
+#define GDOM_DOM_OBJECT_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), GDOM_TYPE_DOM_OBJECT, GdomDOMObjectPrivate))
+
+void
+gdom_dom_object_set_private(GdomDOMObject *request, GDOMObject * item)
+{
+    GdomDOMObjectPrivate* priv = GDOM_DOM_OBJECT_GET_PRIVATE(request);
+    priv->m_node = item;
+    /*priv->m_node->impl()->ref();*/
+}
+
+GDOMObject *
+gdom_dom_object_get_private(GdomDOMObject *request)
+{
+    GdomDOMObjectPrivate* priv = GDOM_DOM_OBJECT_GET_PRIVATE(request);
+    return priv->m_node;
+}
+
+static void gdom_dom_object_finalize(GObject* object)
+{
+    GdomDOMObject* request = GDOM_DOM_OBJECT(object);
+    GdomDOMObjectPrivate* priv = request->priv;
+    
+    /*priv->m_node->impl()->deref();*/
+    delete priv->m_node; /* calls m_impl->deref() */
+
+    G_OBJECT_CLASS(gdom_dom_object_parent_class)->finalize(object);
+}
+
+static void gdom_dom_object_class_init(GdomDOMObjectClass* requestClass)
+{
+    G_OBJECT_CLASS(requestClass)->finalize = gdom_dom_object_finalize;
+    
+    g_type_class_add_private(requestClass, sizeof(GdomDOMObjectPrivate));
+}
+
+static void gdom_dom_object_init(GdomDOMObject* request)
+{
+    GdomDOMObjectPrivate* priv = GDOM_DOM_OBJECT_GET_PRIVATE(request);
+    request->priv = priv;
+}   
+
+} /* extern "C" */
+
Index: WebCore/bindings/gdom/GdomEventTargetNode.h
===================================================================
--- WebCore/bindings/gdom/GdomEventTargetNode.h	(revision 0)
+++ WebCore/bindings/gdom/GdomEventTargetNode.h	(revision 0)
@@ -0,0 +1,47 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+#ifndef __GdomEventTargetNode_H__
+#define __GdomEventTargetNode_H__
+#include "glib-object.h"
+#include <webkit/webkitdefines.h>
+
+G_BEGIN_DECLS
+
+typedef struct _GdomEventTargetNode GdomEventTargetNode;
+typedef struct _GdomEventTargetNodeClass GdomEventTargetNodeClass;
+
+#define GDOM_TYPE_EVENT_TARGET_NODE            (gdom_event_target_node_get_type())
+#define GDOM_EVENT_TARGET_NODE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_EVENT_TARGET_NODE, GdomEventTargetNode))
+#define GDOM_EVENT_TARGET_NODE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_EVENT_TARGET_NODE, GdomEventTargetNodeClass))
+#define GDOM_IS_EVENT_TARGET_NODE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_EVENT_TARGET_NODE))
+#define GDOM_IS_EVENT_TARGET_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_EVENT_TARGET_NODE))
+#define GDOM_EVENT_TARGET_NODE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_EVENT_TARGET_NODE, GdomEventTargetNodeClass))
+
+typedef struct _GdomEventTargetNodePrivate GdomEventTargetNodePrivate;
+
+#include "GdomNode.h"
+
+struct _GdomEventTargetNode {
+    GdomNode parent_instance;
+
+    GdomEventTargetNodePrivate *priv;
+};
+
+struct _GdomEventTargetNodeClass {
+    GdomNodeClass parent_class;
+};
+
+WEBKIT_API GType
+gdom_event_target_node_get_type (void);
+
+WEBKIT_API void
+gdom_event_target_node_init_event_target_node (GdomEventTargetNode *thiz);
+
+G_END_DECLS
+
+#endif /* __GdomEventTargetNode_H__ */
+
Index: WebCore/bindings/gdom/GdomDOMObject.cpp
===================================================================
--- WebCore/bindings/gdom/GdomDOMObject.cpp	(revision 0)
+++ WebCore/bindings/gdom/GdomDOMObject.cpp	(revision 0)
@@ -0,0 +1,30 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+#include "config.h"
+
+#include <wtf/GetPtr.h>
+#include "CString.h"
+#include "PlatformString.h"
+#include "AtomicString.h"
+#include "GdomDOMObject.h"
+#include "glib-object.h"
+
+extern "C" {
+
+void
+gdom_dom_object_init_dom_object (GdomDOMObject *thiz)
+{
+    g_return_if_fail (thiz);
+	/*
+    WebCore::DOMObject * item = gdom_dom_object_get_private(thiz);
+    WebCore::String _g_dom_object_type_arg = WebCore::String(dom_object_type_arg);
+    item->initDOMObject(_g_dom_object_type_arg);
+	*/
+}
+
+} /* extern "C" */
+
Index: WebCore/bindings/gdom/PrivateGdomDOMObject.h
===================================================================
--- WebCore/bindings/gdom/PrivateGdomDOMObject.h	(revision 0)
+++ WebCore/bindings/gdom/PrivateGdomDOMObject.h	(revision 0)
@@ -0,0 +1,23 @@
+/*
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ * Copyright (C) 2008 Alp Toker <alp@atoker.com>
+ * Copyright (C) 2008 Apple Inc.
+ */
+
+
+#ifndef __GDOMDOMObject_H___PRIV_
+#define __GDOMDOMObject_H___PRIV_
+#include "glib-object.h"
+#include "GdomDOMObject.h"
+G_BEGIN_DECLS
+
+class GDOMObject;
+WEBKIT_API GDOMObject*
+gdom_dom_object_get_private(GdomDOMObject *request);
+
+WEBKIT_API void
+gdom_dom_object_set_private(GdomDOMObject *request, GDOMObject* item);
+
+G_END_DECLS
+#endif
+
